import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * A little Girlin that wants to get to the other side.
 */
public class Girl extends Mover
{
    private static final int jumpStrength = 16;
    private boolean canRunRight=true;
    private boolean canMove=false;
    private boolean moveFlag=false;
    private int  cherriesEaten=0;
    private tile t;
    private Actor cherry;

    public void act() 
    {
        if(Greenfoot.isKeyDown("space"))
            canMove=true;
        if(canMove){
            checkGameover();
            move();  
            checkFall();
            checkCollision();
            if(foundCherry()) eatCherry();
        }
    }

    public  void checkCollision() {
        if (blockTop()||getY()<getImage().getHeight()/2) {
            setVSpeed(0);
            if(blockTop()) {
                t=(tile)getOneObjectAtOffset(0 ,-getImage().getHeight()/2, tile.class);
                if (t!=null) 
                    setLocation ( getX(), t.getY() + t.getImage().getHeight()/2+getImage().getHeight()/2);
            } 
            else if(getY()<getImage().getHeight()/2)
                setLocation ( getX(),getImage().getHeight()/2) ;    
        } 
        if(blockRight()||getX()>(getWorld().getWidth()-getImage().getWidth()/2)) { 
            canRunRight=false;
            setImage("left1.png"); 
        }
        if(blockLeft()||getX()<getImage().getWidth()/2) { 
            canRunRight=true;
            setImage("right1.png");
        }

    }

    private void move()
    {
        if( canRunRight==true) { 
            if(moveFlag) setImage("right2.png");
            else setImage("right1.png");
            moveRight();
        }
        else {       
            if(moveFlag) setImage("left2.png");
            else setImage("left1.png");
            moveLeft();
        }
        if(onGround())
            moveFlag=!moveFlag;
            
        t=(tile)getOneObjectAtOffset(0, getImage().getHeight()/2 , tile.class);
        if (t!=null&&t.gettype()==1){  
            Greenfoot.playSound("jump.wav");
            jump();
        }    
    }    

    private void jump()
    {
        setVSpeed(-jumpStrength);
        fall();
    }

    private void checkFall()
    {
        if (onGround()) {
            t=(tile)getOneObjectAtOffset(0, getImage().getHeight()/2 , tile.class);
            if (t!=null) 
                setLocation ( getX(), t.getY()-getImage().getHeight()/2-getImage().getHeight()/2);
            setVSpeed(0);
        }
        else {
            fall();
        }
    }

    public boolean foundCherry()
    {
        cherry = getOneIntersectingObject( Cherry.class);
        if(cherry  != null) {
            return true;
        }
        else {
            return false;
        }
    }

    public void eatCherry()
    {
        cherry  = getOneIntersectingObject( Cherry.class);
        if(cherry  != null) {
            Greenfoot.playSound("eat.wav");
            getWorld().removeObject(cherry);
            cherriesEaten =cherriesEaten + 1; 
        }
    }

    public int getCherries()   {
        return  cherriesEaten;
    }

    public void checkGameover() {
        if(cherriesEaten==((CherryWorld)getWorld()).TOTALCHERRIES)
            ((CherryWorld)getWorld()).gameOver("Finished!");
    }
}
