import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.awt.Color;
import java.awt.Font;
import java.util.Calendar;

/**
 * The ScoreBoard is used to display results on the screen. It can display some
 * text and several numbers.
 * 
 * @author M Kolling
 * @version 1.0
 */
public class ScoreBoard extends Actor
{
    public static final float FONT_SIZE = 48.0f;
    public static final int WIDTH = 400;
    public static final int HEIGHT = 300;

    /**
     * Create a score board for the final result.
     */
    public ScoreBoard(String title ,long time)
    {
        makeImage(title,time);
    }

    /**
     * Make the score board image.
     */
    private void makeImage(String title,long time)
    {
        GreenfootImage image = new GreenfootImage(WIDTH, HEIGHT);

        image.setColor(new Color(0, 0, 0, 160));
        image.fillRect(0, 0, WIDTH, HEIGHT);
        image.setColor(new Color(255, 255, 255, 100));
        image.fillRect(5, 5, WIDTH-10, HEIGHT-10);
        Font font = image.getFont();
        font = font.deriveFont(FONT_SIZE);
        image.setFont(font);
        image.setColor(Color.WHITE);
        image.drawString(title, 60, 80);
        if(title.equals("Finished!")) {
            image.drawString("Time : " + time+"s" , 60, 160);
            image.drawString(getGrade(time), 60, 240);
        }
        else if(title.equals("Failed!"))
            image.drawString("Try Again!" , 60, 200);
        setImage(image);
    }

    private String getGrade(long time){
        String s;
        switch((int)(time/50)){
            case 0: s="Perfect!";break;
            case 1: s="Great!";break;
            case 2:
            case 3: s="Good!";break;
            case 4:
            case 5: s="Medium";break;
            default:s="Bad!";break;
        }
        return s;
    }
}
